﻿class Bouncer extends GameObject
{
    constructor() {

        //call the constructor in the base class
        super();

        this.setTypeID(2); //set as a "enemy" in the collision system

        //2D width and height
        //NOTE: YOU ALMOST ALWAYS WANT THESE TO BE THE SAME
        //this defines a 2D coord scale
        var w = 50; //Math.random() * 250;
        var h = 50; //Math.random() * 250;

        //2D diameter for circles
        var d = 50;

        //width, height, and depth of attached model
        //note that we're showing off that these can be 
        //different from the poly, or from width or height
        var sw = 150; 
        var sh = 150;
        var sd = 150;

        //randomly create cubes, circles, and polys
        var x = Math.random();
        if (x < 0.4) {
            this.initAsBox(w, 20, w, 20, w); //init as a box 
            this.setMeshID(0);
        } else if (x < 0.7) {
            this.initAsPoly(w, h, sw, sh, sd, [[-w / 2, -h / 2], [0, (-h / 2) - 10], [w / 2, -h / 2], [w / 2, h / 2], [-w / 2, h / 2]]);
            this.setMeshID(2);
        } else {
            this.initAsCircle(d, d, d, d);
            this.setMeshID(1);
            
        }
        
        //create a random position
        this._position.x = (Math.random() - 0.5) * 1920;
        this._position.y = (Math.random() - 0.5) * 1080;
        this._position.z = (Math.random() - 0.5) * 50;

        //random vales for moving around
        this._speed = Math.random() * 5;
        this._speedX = (Math.random()-0.5) * 3;
        this._speedY = (Math.random()-0.5) * 3;
    }

    //called per frame...
    update() {
        this.move();
    }

    move() {

        //bounce around on the X axis
        if (this._2dPosX > -GAME_WINDOW.GAME_WINDOW_UNSCALED_HALF_WIDTH &&
            this._2dPosX < GAME_WINDOW.GAME_WINDOW_UNSCALED_HALF_WIDTH) { //absolute 2D coords
            
            this._position.x += this._speedX;  //(scale adjusted movement);
            //this._position.z += 0.5;
        } else {
            this._speedX = -this._speedX;
            this._position.x += this._speedX;
        }

        //bounce around on the Y axis
        if (this._2dPosY > -GAME_WINDOW.GAME_WINDOW_UNSCALED_HALF_HEIGHT &&
           this._2dPosY < GAME_WINDOW.GAME_WINDOW_UNSCALED_HALF_HEIGHT) { //absolute 2D coords

            this._position.y += this._speedY;  //(scale adjusted movement);
            //this._position.z += 0.5;
        } else {
            this._speedY = -this._speedY;
            this._position.y += this._speedY;
        }

        //if of type 2 (from model list) then spin on Y axis
        if (this._meshID == 2) {
            this._rotation.y += this._speed * Math.PI / 180;
        }
    }

    //REQUIRED CALLBACK... called when there is a 
    //collision thrown to this object
    collision(gO) {
        //console.log("collision on bouncer " + FPS_COUNTER._frameCount);
    }
}